# coding: utf-8

"""
    SQL Server Big Data Cluster API

    OpenAPI specification for **SQL Server Big Data Cluster**.  # noqa: E501

    OpenAPI spec version: 2.0.0

    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from azdata.cli.core.clients.api_client import ApiClient


class ConfigurationRouterApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client


    def api_vversion_bdc_config_get(self, version, **kwargs):  # noqa: E501
        """Get configuration settings for the cluster.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_vversion_bdc_config_get(version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: (required)
        :param str filter_option: The boolean flag value to show settings that are configurable by user.
        :param bool recursive: The boolean flag value to show all settings in the cluster in the given scope.
        :param list[str] settings: The boolean flag value to show all settings in the cluster.
        :param bool include_details: The boolean flag value to show details of the settings in the cluster.
        :return: ClusterSettingsResponseModel
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.api_vversion_bdc_config_get_with_http_info(version, **kwargs)  # noqa: E501
        else:
            (data) = self.api_vversion_bdc_config_get_with_http_info(version, **kwargs)  # noqa: E501
            return data

    def api_vversion_bdc_config_get_with_http_info(self, version, **kwargs):  # noqa: E501
        """Get configuration settings for the cluster.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_vversion_bdc_config_get_with_http_info(version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: (required)
        :param str filter_option: The boolean flag value to show settings that are configurable by user.
        :param bool recursive: The boolean flag value to show all settings in the cluster in the given scope.
        :param list[str] settings: The boolean flag value to show all settings in the cluster.
        :param bool include_details: The boolean flag value to show details of the settings in the cluster.
        :return: ClusterSettingsResponseModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['version', 'filter_option', 'recursive', 'settings', 'include_details']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method api_vversion_bdc_config_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `api_vversion_bdc_config_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'version' in params:
            path_params['version'] = params['version']  # noqa: E501

        query_params = []
        if 'filter_option' in params:
            query_params.append(('filterOption', params['filter_option']))  # noqa: E501
        if 'recursive' in params:
            query_params.append(('recursive', params['recursive']))  # noqa: E501
        if 'settings' in params:
            query_params.append(('settings', params['settings']))  # noqa: E501
            collection_formats['settings'] = 'multi'  # noqa: E501
        if 'include_details' in params:
            query_params.append(('includeDetails', params['include_details']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'BearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/api/v{version}/bdc/config', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=object,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def api_vversion_bdc_config_patch(self, version, **kwargs):  # noqa: E501
        """Upgrade configuration settings for cluster.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_vversion_bdc_config_patch(version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: (required)
        :param ConfigurationUpgradeRequest body:
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.api_vversion_bdc_config_patch_with_http_info(version, **kwargs)  # noqa: E501
        else:
            (data) = self.api_vversion_bdc_config_patch_with_http_info(version, **kwargs)  # noqa: E501
            return data

    def api_vversion_bdc_config_patch_with_http_info(self, version, **kwargs):  # noqa: E501
        """Upgrade configuration settings for cluster.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_vversion_bdc_config_patch_with_http_info(version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: (required)
        :param ConfigurationUpgradeRequest body:
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['version', 'body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method api_vversion_bdc_config_patch" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `api_vversion_bdc_config_patch`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'version' in params:
            path_params['version'] = params['version']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json-patch+json', 'application/json', 'text/json', 'application/*+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'BearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/api/v{version}/bdc/config', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def api_vversion_bdc_config_post(self, version, **kwargs):  # noqa: E501
        """Set configuration settings for cluster.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_vversion_bdc_config_post(version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: (required)
        :param ConfigurationSettingRequestModel body:
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.api_vversion_bdc_config_post_with_http_info(version, **kwargs)  # noqa: E501
        else:
            (data) = self.api_vversion_bdc_config_post_with_http_info(version, **kwargs)  # noqa: E501
            return data

    def api_vversion_bdc_config_post_with_http_info(self, version, **kwargs):  # noqa: E501
        """Set configuration settings for cluster.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_vversion_bdc_config_post_with_http_info(version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: (required)
        :param ConfigurationSettingRequestModel body:
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['version', 'body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method api_vversion_bdc_config_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError(
                "Missing the required parameter `version` when calling `api_vversion_bdc_config_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'version' in params:
            path_params['version'] = params['version']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json-patch+json', 'application/json', 'text/json', 'application/*+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'BearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/api/v{version}/bdc/config', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def api_vversion_bdc_config_revert_patch(self, version, **kwargs):  # noqa: E501
        """Revert pending configuration settings for cluster.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_vversion_bdc_config_revert_patch(version, async_req=True)
        >>> result = thread.get()
        :param async_req bool
        :param str version: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.api_vversion_bdc_config_revert_patch_with_http_info(version, **kwargs)  # noqa: E501
        else:
            (data) = self.api_vversion_bdc_config_revert_patch_with_http_info(version, **kwargs)  # noqa: E501
            return data

    def api_vversion_bdc_config_revert_patch_with_http_info(self, version, **kwargs):  # noqa: E501
        """Revert pending configuration settings for cluster.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_vversion_bdc_config_revert_patch_with_http_info(version, async_req=True)
        >>> result = thread.get()
        :param async_req bool
        :param str version: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        all_params = ['version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method api_vversion_bdc_config_revert_patch" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError(
                "Missing the required parameter `version` when calling `api_vversion_bdc_config_revert_patch`")  # noqa: E501
        collection_formats = {}
        path_params = {}
        if 'version' in params:
            path_params['version'] = params['version']  # noqa: E501
        query_params = []
        header_params = {}
        form_params = []
        local_var_files = {}
        body_params = None
        # Authentication setting
        auth_settings = ['BasicAuth', 'BearerAuth']  # noqa: E501
        return self.api_client.call_api(
            '/api/v{version}/bdc/config/revert', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def api_vversion_bdc_services_service_name_config_get(self, service_name, version, **kwargs):  # noqa: E501
        """Get configuration settings for specific service.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_vversion_bdc_services_service_name_config_get(service_name, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str service_name: The name of the service you would like to view the settings. (required)
        :param str version: (required)
        :param str filter_option: The option to filter the settings.
        :param bool recursive: The boolean flag value to show all settings in the cluster in the given scope.
        :param list[str] settings: The boolean flag value to show all settings in the cluster.
        :param bool include_details: The boolean flag value to show details of the settings in the cluster.
        :return: ServiceSettingsResponseModel
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.api_vversion_bdc_services_service_name_config_get_with_http_info(service_name, version, **kwargs)  # noqa: E501
        else:
            (data) = self.api_vversion_bdc_services_service_name_config_get_with_http_info(service_name, version, **kwargs)  # noqa: E501
            return data

    def api_vversion_bdc_services_service_name_config_get_with_http_info(self, service_name, version, **kwargs):  # noqa: E501
        """Get configuration settings for specific service.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_vversion_bdc_services_service_name_config_get_with_http_info(service_name, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str service_name: The name of the service you would like to view the settings. (required)
        :param str version: (required)
        :param str filter_option: The option to filter the settings.
        :param bool recursive: The boolean flag value to show all settings in the cluster in the given scope.
        :param list[str] settings: The boolean flag value to show all settings in the cluster.
        :param bool include_details: The boolean flag value to show details of the settings in the cluster.
        :return: ServiceSettingsResponseModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['service_name', 'version', 'filter_option', 'recursive', 'settings', 'include_details']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method api_vversion_bdc_services_service_name_config_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'service_name' is set
        if ('service_name' not in params or
                params['service_name'] is None):
            raise ValueError("Missing the required parameter `service_name` when calling `api_vversion_bdc_services_service_name_config_get`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `api_vversion_bdc_services_service_name_config_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'service_name' in params:
            path_params['serviceName'] = params['service_name']  # noqa: E501
        if 'version' in params:
            path_params['version'] = params['version']  # noqa: E501

        query_params = []
        if 'filter_option' in params:
            query_params.append(('filterOption', params['filter_option']))  # noqa: E501
        if 'recursive' in params:
            query_params.append(('recursive', params['recursive']))  # noqa: E501
        if 'settings' in params:
            query_params.append(('settings', params['settings']))  # noqa: E501
            collection_formats['settings'] = 'multi'  # noqa: E501
        if 'include_details' in params:
            query_params.append(('includeDetails', params['include_details']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'BearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/api/v{version}/bdc/services/{serviceName}/config', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=object,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def api_vversion_bdc_services_service_name_config_post(self, service_name, version, **kwargs):  # noqa: E501
        """Set configuration settings for specific service.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_vversion_bdc_services_service_name_config_post(service_name, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str service_name: The name of the service you would like to configure. (required)
        :param str version: (required)
        :param ConfigurationSettingRequestModel body:
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.api_vversion_bdc_services_service_name_config_post_with_http_info(service_name, version,
                                                                                          **kwargs)  # noqa: E501
        else:
            (data) = self.api_vversion_bdc_services_service_name_config_post_with_http_info(service_name, version,
                                                                                            **kwargs)  # noqa: E501
            return data

    def api_vversion_bdc_services_service_name_config_post_with_http_info(self, service_name, version,
                                                                          **kwargs):  # noqa: E501
        """Set configuration settings for specific service.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_vversion_bdc_services_service_name_config_post_with_http_info(service_name, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str service_name: The name of the service you would like to configure. (required)
        :param str version: (required)
        :param ConfigurationSettingRequestModel body:
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['service_name', 'version', 'body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method api_vversion_bdc_services_service_name_config_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'service_name' is set
        if ('service_name' not in params or
                params['service_name'] is None):
            raise ValueError(
                "Missing the required parameter `service_name` when calling `api_vversion_bdc_services_service_name_config_post`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError(
                "Missing the required parameter `version` when calling `api_vversion_bdc_services_service_name_config_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'service_name' in params:
            path_params['serviceName'] = params['service_name']  # noqa: E501
        if 'version' in params:
            path_params['version'] = params['version']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json-patch+json', 'application/json', 'text/json', 'application/*+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'BearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/api/v{version}/bdc/services/{serviceName}/config', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def api_vversion_bdc_services_service_name_resources_resource_name_config_get(self, service_name, resource_name, version, **kwargs):  # noqa: E501
        """Get configuration settings for specific service and resource.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_vversion_bdc_services_service_name_resources_resource_name_config_get(service_name, resource_name, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str service_name: The name of the service you would like to view the settings. (required)
        :param str resource_name: The name of the resource you would like to view the settings. (required)
        :param str version: (required)
        :param str filter_option: The option to filter the setttings.
        :param bool recursive: The boolean flag value to show all settings in the cluster in the given scope.
        :param list[str] settings: The boolean flag value to show all settings in the cluster.
        :param bool include_details: The boolean flag value to show details of the settings in the cluster.
        :return: ResourceSettingsResponseModel
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.api_vversion_bdc_services_service_name_resources_resource_name_config_get_with_http_info(service_name, resource_name, version, **kwargs)  # noqa: E501
        else:
            (data) = self.api_vversion_bdc_services_service_name_resources_resource_name_config_get_with_http_info(service_name, resource_name, version, **kwargs)  # noqa: E501
            return data

    def api_vversion_bdc_services_service_name_resources_resource_name_config_get_with_http_info(self, service_name, resource_name, version, **kwargs):  # noqa: E501
        """Get configuration settings for specific service and resource.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_vversion_bdc_services_service_name_resources_resource_name_config_get_with_http_info(service_name, resource_name, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str service_name: The name of the service you would like to view the settings. (required)
        :param str resource_name: The name of the resource you would like to view the settings. (required)
        :param str version: (required)
        :param str filter_option: The option to filter the setttings.
        :param bool recursive: The boolean flag value to show all settings in the cluster in the given scope.
        :param list[str] settings: The boolean flag value to show all settings in the cluster.
        :param bool include_details: The boolean flag value to show details of the settings in the cluster.
        :return: ResourceSettingsResponseModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['service_name', 'resource_name', 'version', 'filter_option', 'recursive', 'settings', 'include_details']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method api_vversion_bdc_services_service_name_resources_resource_name_config_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'service_name' is set
        if ('service_name' not in params or
                params['service_name'] is None):
            raise ValueError("Missing the required parameter `service_name` when calling `api_vversion_bdc_services_service_name_resources_resource_name_config_get`")  # noqa: E501
        # verify the required parameter 'resource_name' is set
        if ('resource_name' not in params or
                params['resource_name'] is None):
            raise ValueError("Missing the required parameter `resource_name` when calling `api_vversion_bdc_services_service_name_resources_resource_name_config_get`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `api_vversion_bdc_services_service_name_resources_resource_name_config_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'service_name' in params:
            path_params['serviceName'] = params['service_name']  # noqa: E501
        if 'resource_name' in params:
            path_params['resourceName'] = params['resource_name']  # noqa: E501
        if 'version' in params:
            path_params['version'] = params['version']  # noqa: E501

        query_params = []
        if 'filter_option' in params:
            query_params.append(('filterOption', params['filter_option']))  # noqa: E501
        if 'recursive' in params:
            query_params.append(('recursive', params['recursive']))  # noqa: E501
        if 'settings' in params:
            query_params.append(('settings', params['settings']))  # noqa: E501
            collection_formats['settings'] = 'multi'  # noqa: E501
        if 'include_details' in params:
            query_params.append(('includeDetails', params['include_details']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'BearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/api/v{version}/bdc/services/{serviceName}/resources/{resourceName}/config', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=object,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def api_vversion_bdc_services_service_name_resources_resource_name_config_post(self, service_name, resource_name,
                                                                                   version, **kwargs):  # noqa: E501
        """Set configuration settings for specific service and resource.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_vversion_bdc_services_service_name_resources_resource_name_config_post(service_name, resource_name, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str service_name: The name of the service you would like to configure. (required)
        :param str resource_name: The name of the resource you would like to configure. (required)
        :param str version: (required)
        :param ConfigurationSettingRequestModel body:
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.api_vversion_bdc_services_service_name_resources_resource_name_config_post_with_http_info(
                service_name, resource_name, version, **kwargs)  # noqa: E501
        else:
            (data) = self.api_vversion_bdc_services_service_name_resources_resource_name_config_post_with_http_info(
                service_name, resource_name, version, **kwargs)  # noqa: E501
            return data

    def api_vversion_bdc_services_service_name_resources_resource_name_config_post_with_http_info(self, service_name,
                                                                                                  resource_name,
                                                                                                  version,
                                                                                                  **kwargs):  # noqa: E501
        """Set configuration settings for specific service and resource.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_vversion_bdc_services_service_name_resources_resource_name_config_post_with_http_info(service_name, resource_name, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str service_name: The name of the service you would like to configure. (required)
        :param str resource_name: The name of the resource you would like to configure. (required)
        :param str version: (required)
        :param ConfigurationSettingRequestModel body:
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['service_name', 'resource_name', 'version', 'body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method api_vversion_bdc_services_service_name_resources_resource_name_config_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'service_name' is set
        if ('service_name' not in params or
                params['service_name'] is None):
            raise ValueError(
                "Missing the required parameter `service_name` when calling `api_vversion_bdc_services_service_name_resources_resource_name_config_post`")  # noqa: E501
        # verify the required parameter 'resource_name' is set
        if ('resource_name' not in params or
                params['resource_name'] is None):
            raise ValueError(
                "Missing the required parameter `resource_name` when calling `api_vversion_bdc_services_service_name_resources_resource_name_config_post`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError(
                "Missing the required parameter `version` when calling `api_vversion_bdc_services_service_name_resources_resource_name_config_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'service_name' in params:
            path_params['serviceName'] = params['service_name']  # noqa: E501
        if 'resource_name' in params:
            path_params['resourceName'] = params['resource_name']  # noqa: E501
        if 'version' in params:
            path_params['version'] = params['version']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json-patch+json', 'application/json', 'text/json', 'application/*+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'BearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/api/v{version}/bdc/services/{serviceName}/resources/{resourceName}/config', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
