# ------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# ------------------------------------------------------------------------------
from azdata.cli.commands.config.util import hierarchical_output
from azdata.cli.core.commands import CliCommandGroup
from azdata.cli.commands.config import client


def load_command_table(self, _):
    with CliCommandGroup(self, 'bdc settings',
                         'azdata.cli.commands.config.custom#{}',
                         client_factory=client.beget) as g:
        g.command('apply', 'config_upgrade')
        g.command('cancel-apply', 'config_abort_upgrade')
        g.command('set', 'bdc_config_set')
        g.command('show', 'bdc_settings_show', output=hierarchical_output, override_output=['table'])
        g.command('revert', 'config_revert')

    with CliCommandGroup(self, 'bdc sql settings',
                         'azdata.cli.commands.config.custom#{}',
                         client_factory=client.beget) as g:
        g.command('set', 'bdc_sql_config_set')
        g.command('show', 'bdc_sql_settings_show', output=hierarchical_output, override_output=['table'])

    with CliCommandGroup(self, 'bdc hdfs settings',
                         'azdata.cli.commands.config.custom#{}',
                         client_factory=client.beget) as g:
        g.command('set', 'bdc_hdfs_config_set')
        g.command('show', 'bdc_hdfs_settings_show', output=hierarchical_output, override_output=['table'])

    with CliCommandGroup(self, 'bdc spark settings',
                         'azdata.cli.commands.config.custom#{}',
                         client_factory=client.beget) as g:
        g.command('set', 'bdc_spark_config_set')
        g.command('show', 'bdc_spark_settings_show', output=hierarchical_output, override_output=['table'])

    with CliCommandGroup(self, 'bdc gateway settings',
                         'azdata.cli.commands.config.custom#{}',
                         client_factory=client.beget) as g:
        g.command('set', 'bdc_gateway_config_set')
        g.command('show', 'bdc_gateway_settings_show', output=hierarchical_output, override_output=['table'])

    with CliCommandGroup(self, 'bdc app settings',
                         'azdata.cli.commands.config.custom#{}',
                         client_factory=client.beget) as g:
        g.command('set', 'bdc_app_config_set')
        g.command('show', 'bdc_app_settings_show', output=hierarchical_output, override_output=['table'])
