# ------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# ------------------------------------------------------------------------------


def load_arguments(self, _):
    from knack.arguments import ArgumentsContext
    from azdata.cli.commands.hdfsencryptionzone import _

    with ArgumentsContext(self, 'bdc hdfs encryption-zone create') as arg_context:
        arg_context.argument(
            'folder_path',
            options_list=['--path', '-p'],
            help=_('HDFS folder path which should be converted to an encryption zone. The folder'
             ' should be empty.')
        )

        arg_context.argument(
            'key_name',
            options_list=['--keyname', '-k'],
            help=_('Hadoop KMS key to be used to protect the encryption '
                   'zone.')
        )

        arg_context.argument(
            'folder_path',
            options_list=['--path', '-p'],
            help=_('Path of the HDFS folder to be converted to encryption '
                   'zone.')
        )

    with ArgumentsContext(self, 'bdc hdfs encryption-zone list') as arg_context:
        pass

    with ArgumentsContext(self, 'bdc hdfs encryption-zone get-file-encryption-info') as arg_context:
        arg_context.argument(
            'file_path',
            options_list=['--path', '-p'],
            help=_('HDFS file path for which encryption information '
                   'should be retrieved.')
        )

    with ArgumentsContext(self, 'bdc hdfs encryption-zone reencrypt') as arg_context:
        arg_context.argument(
            'folder_path',
            options_list=['--path', '-p'],
            help=_('Path of the HDFS encryption zone folder which should be re-encrypted')
        )

        arg_context.argument(
            'action',
            options_list=['--action', '-a'],
            help=_('Re-encryption action to be performed. Valid values are start and cancel')
        )

    with ArgumentsContext(self, 'bdc hdfs encryption-zone status') as arg_context:
        pass