# ------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# ------------------------------------------------------------------------------

class FormatEncryptionZones():
    @staticmethod
    def format_encryption_zones(encryption_zones):
        table = []
        for encryption_zone in encryption_zones["EncryptionZone"]:
            row = {'path': encryption_zone['path'], 'key': encryption_zone['keyName']}
            table.append(row)
        return table

    @staticmethod
    def format_zone_reencryption_status(reencryption_statuses):
        table = []
        for status in reencryption_statuses['ZoneReencryptionStatus']:
            keys = ['zoneName', 'encryptionZoneKeyVersionName', 'status', 'failureCount', 'fileReencryptionCount',
                    'isCanceled', 'lastCheckpointFile', 'submissionTime', 'completionTime']
            row = {k: status[k] for k in keys}
            table.append(row)
        return table