# ------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# ------------------------------------------------------------------------------


def load_arguments(self, _):
    from knack.arguments import ArgumentsContext
    from azdata.cli.commands.hdfskey import _

    with ArgumentsContext(self, "bdc hdfs key create") as arg_context:
        arg_context.argument(
            "name",
            options_list=["--name", "-n"],
            help=_("Name of the Hadoop encryption zone key. "),
        )

        arg_context.argument(
            "size",
            options_list=["--size", "-size"],
            help=_(
                "Bit length of the Hadoop encryption key, default length is 256."
            ),
        )

    with ArgumentsContext(self, "bdc hdfs key roll") as arg_context:
        arg_context.argument(
            "name",
            options_list=["--name", "-n"],
            help=_(
                "Name of the encryption zone key to roll to a new version. "
            ),
        )

    with ArgumentsContext(self, "bdc hdfs key list") as arg_context:
        pass

    with ArgumentsContext(self, "bdc hdfs key describe") as arg_context:
        arg_context.argument(
            "name",
            options_list=["--name", "-n"],
            help=_(
                "Name of the encryption zone key to describe. "
            ),
        )