# ------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# ------------------------------------------------------------------------------

from knack.help_files import helps
from azdata.cli.commands.hdfskey import _


# pylint: disable=line-too-long
helps[
    "bdc hdfs key"
] = """
    type: group
    short-summary: {short}
""".format(
    short=_("Manage Hadoop encryption zone keys.")
)

helps[
    "bdc hdfs key create"
] = """
    type: command
    short-summary: {short}
    long-summary: {long}
    examples:
        - name: {ex1}
          text: >
            azdata hdfs key create --name key1 --size 256
""".format(
    short=_("Create a HDFS key."),
    long=_("Create a HDFS key with given name, and given size."),
    ex1=_(
        "To create a 256 bit key with name key1, azdata hdfs key create --name key1 --size 256"
    ),
)

helps[
    "bdc hdfs key list"
] = """
    type: command
    short-summary: {short}
    examples:
        - name: {ex1}
          text: >
            azdata bdc hdfs key list
""".format(
    short=_("Lists all Hadoop encryption zone keys."),
    ex1=_("List all Hadoop encryption zone keys, azdata bdc hdfs key list"),
)

helps[
    "bdc hdfs key roll"
] = """
    type: command
    short-summary: {short}
    long-summary: {long}
    examples:
        - name: {ex1}
          text: >
            azdata hdfs key roll --name key1
""".format(
    short=_("Roll a HDFS key."),
    long=_("Roll a HDFS key with given name."),
    ex1=_("To roll a key with name key1, azdata hdfs key roll --name key1."),
)


helps[
    "bdc hdfs key describe"
] = """
    type: command
    short-summary: {short}
    examples:
        - name: {ex1}
          text: >
            azdata hdfs key describe --name key1
""".format(
    short=_("Shows details of an encryption zone key."),
    ex1=_("To show the details of a key with name key1."),
)