# coding: utf-8

"""
    SQL Server Big Data Cluster API

    OpenAPI specification for **SQL Server Big Data Cluster**.  # noqa: E501

    OpenAPI spec version: 2.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from azdata.cli.core.clients.api_client import ApiClient


class KmsRouterApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def api_vversion_bdc_kms_config_get(self, version, **kwargs):  # noqa: E501
        """Get information about the latest key configured at root level for encryption.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_vversion_bdc_kms_config_get(version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: (required)
        :return: KmsKeyConfigurationResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.api_vversion_bdc_kms_config_get_with_http_info(version, **kwargs)  # noqa: E501
        else:
            (data) = self.api_vversion_bdc_kms_config_get_with_http_info(version, **kwargs)  # noqa: E501
            return data

    def api_vversion_bdc_kms_config_get_with_http_info(self, version, **kwargs):  # noqa: E501
        """Get information about the latest key configured at root level for encryption.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_vversion_bdc_kms_config_get_with_http_info(version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: (required)
        :return: KmsKeyConfigurationResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method api_vversion_bdc_kms_config_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `api_vversion_bdc_kms_config_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'version' in params:
            path_params['version'] = params['version']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'BearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/api/v{version}/bdc/kms/config', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=object,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def api_vversion_bdc_kms_config_post(self, version, **kwargs):  # noqa: E501
        """Configure the source of the main encryption key protecting the keys used for encryption at rest.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_vversion_bdc_kms_config_post(version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: (required)
        :param KmsKeyConfigurationRequest body:
        :return: KmsKeyConfigurationResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.api_vversion_bdc_kms_config_post_with_http_info(version, **kwargs)  # noqa: E501
        else:
            (data) = self.api_vversion_bdc_kms_config_post_with_http_info(version, **kwargs)  # noqa: E501
            return data

    def api_vversion_bdc_kms_config_post_with_http_info(self, version, **kwargs):  # noqa: E501
        """Configure the source of the main encryption key protecting the keys used for encryption at rest.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_vversion_bdc_kms_config_post_with_http_info(version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: (required)
        :param KmsKeyConfigurationRequest body:
        :return: KmsKeyConfigurationResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['version', 'body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method api_vversion_bdc_kms_config_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `api_vversion_bdc_kms_config_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'version' in params:
            path_params['version'] = params['version']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json-patch+json', 'application/json', 'text/json', 'application/*+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BasicAuth', 'BearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/api/v{version}/bdc/kms/config', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=object,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
