# ------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# ------------------------------------------------------------------------------

def load_arguments(self, _):
    from knack.arguments import ArgumentsContext
    from azdata.cli.commands.kms import _

    with ArgumentsContext(self, "bdc kms update") as arg_context:
        arg_context.argument(
            'provider',
            options_list=['--provider'],
            choices=('External', 'SystemManaged'),
            help=_(
                'The key provider to update the main keys.'
            )
        )

        arg_context.argument(
            'key_attributes',
            options_list=('--key-attributes'),
            help=_(
                'Key value pairs specifying the key attributes for KMS plugin application. Ex: key1="value",key2="v2"'
            )
        )

        arg_context.argument(
            'app_name',
            options_list=('--app-name'),
            help=_(
                'The name of the Application Deployment application for external key.'
            )
        )

        arg_context.argument(
            'app_version',
            options_list=('--app-version'),
            help=_(
                'The version of the Application Deployment application for external key.'
            )
        )

    with ArgumentsContext(self, "bdc kms show") as arg_context:
        pass