# ------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# ------------------------------------------------------------------------------

from knack.help_files import helps
from azdata.cli.commands.kms import _


# pylint: disable=line-too-long
helps[
    "bdc kms"
] = """
    type: group
    short-summary: {short}
""".format(
    short=_("Update and show the key sources.")
)

# pylint: disable=line-too-long
helps[
    "bdc kms update"
] = """
    type: command
    short-summary: {short}
    long-summary: {long}
    examples:
        - name: {ex1}
          text: >
            azdata bdc kms update --provider SystemManaged
""".format(
    short=_("Updates the KMS to use a key specified by key provider."),
    long=_("Updates the KMS to update the main keys to point to the specified provider. For system managed provider, the key is generated in the KMS and a new version is added to the key. Existing key versions remain unmodified with this operation."),
    ex1=_("Updates the KMS to generate a new key which is system managed."),
)

# pylint: disable=line-too-long
helps[
    "bdc kms show"
] = """
    type: command
    short-summary: {short}
    examples:
        - name: {ex1}
          text: >
            azdata bdc kms show
""".format(
    short=_("Shows the details of the latest key version for the main keys in the KMS."),
    ex1=_("Shows the details of the latest key version."),
)
