# coding: utf-8

"""
    SQL Server Big Data Cluster API

    OpenAPI specification for **SQL Server Big Data Cluster**.  # noqa: E501

    OpenAPI spec version: 2.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class KmsKeyConfigurationRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'key_provider': 'int',
        'key_attributes': 'dict(str, str)',
        'key_pin': 'str',
        'key_application_name': 'str',
        'key_application_version': 'str'
    }

    attribute_map = {
        'key_provider': 'keyProvider',
        'key_attributes': 'keyAttributes',
        'key_pin': 'keyPin',
        'key_application_name': 'keyApplicationName',
        'key_application_version': 'keyApplicationVersion'
    }

    def __init__(self, key_provider=None, key_attributes=None, key_pin=None, key_application_name=None, key_application_version=None):  # noqa: E501
        """KmsKeyConfigurationRequest - a model defined in Swagger"""  # noqa: E501
        self._key_provider = None
        self._key_attributes = None
        self._key_pin = None
        self._key_application_name = None
        self._key_application_version = None
        self.discriminator = None
        self.key_provider = key_provider
        if key_attributes is not None:
            self.key_attributes = key_attributes
        if key_pin is not None:
            self.key_pin = key_pin
        if key_application_name is not None:
            self.key_application_name = key_application_name
        if key_application_version is not None:
            self.key_application_version = key_application_version

    @property
    def key_provider(self):
        """Gets the key_provider of this KmsKeyConfigurationRequest.  # noqa: E501


        :return: The key_provider of this KmsKeyConfigurationRequest.  # noqa: E501
        :rtype: int
        """
        return self._key_provider

    @key_provider.setter
    def key_provider(self, key_provider):
        """Sets the key_provider of this KmsKeyConfigurationRequest.


        :param key_provider: The key_provider of this KmsKeyConfigurationRequest.  # noqa: E501
        :type: int
        """
        if key_provider is None:
            raise ValueError("Invalid value for `key_provider`, must not be `None`")  # noqa: E501
        allowed_values = ["SystemManaged", "External"]  # noqa: E501
        if key_provider not in allowed_values:
            raise ValueError(
                "Invalid value for `key_provider` ({0}), must be one of {1}"  # noqa: E501
                .format(key_provider, allowed_values)
            )

        self._key_provider = key_provider

    @property
    def key_attributes(self):
        """Gets the key_attributes of this KmsKeyConfigurationRequest.  # noqa: E501


        :return: The key_attributes of this KmsKeyConfigurationRequest.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._key_attributes

    @key_attributes.setter
    def key_attributes(self, key_attributes):
        """Sets the key_attributes of this KmsKeyConfigurationRequest.


        :param key_attributes: The key_attributes of this KmsKeyConfigurationRequest.  # noqa: E501
        :type: dict(str, str)
        """

        self._key_attributes = key_attributes

    @property
    def key_pin(self):
        """Gets the key_pin of this KmsKeyConfigurationRequest.  # noqa: E501


        :return: The key_pin of this KmsKeyConfigurationRequest.  # noqa: E501
        :rtype: str
        """
        return self._key_pin

    @key_pin.setter
    def key_pin(self, key_pin):
        """Sets the key_pin of this KmsKeyConfigurationRequest.


        :param key_pin: The key_pin of this KmsKeyConfigurationRequest.  # noqa: E501
        :type: str
        """

        self._key_pin = key_pin

    @property
    def key_application_name(self):
        """Gets the key_application_name of this KmsKeyConfigurationRequest.  # noqa: E501


        :return: The key_application_name of this KmsKeyConfigurationRequest.  # noqa: E501
        :rtype: str
        """
        return self._key_application_name

    @key_application_name.setter
    def key_application_name(self, key_application_name):
        """Sets the key_application_name of this KmsKeyConfigurationRequest.


        :param key_application_name: The key_application_name of this KmsKeyConfigurationRequest.  # noqa: E501
        :type: str
        """

        self._key_application_name = key_application_name

    @property
    def key_application_version(self):
        """Gets the key_application_version of this KmsKeyConfigurationRequest.  # noqa: E501


        :return: The key_application_version of this KmsKeyConfigurationRequest.  # noqa: E501
        :rtype: str
        """
        return self._key_application_version

    @key_application_version.setter
    def key_application_version(self, key_application_version):
        """Sets the key_application_version of this KmsKeyConfigurationRequest.


        :param key_application_version: The key_application_version of this KmsKeyConfigurationRequest.  # noqa: E501
        :type: str
        """

        self._key_application_version = key_application_version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(KmsKeyConfigurationRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, KmsKeyConfigurationRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
