# ------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# ------------------------------------------------------------------------------

from azdata.cli.commands.rotate.api.password_router_api import PasswordRouterApi
from azdata.cli.core.clients.controller_client import RefreshRetry
from azdata.cli.core.exceptions import ApiError, ControllerError

# This file contains plugins for ControllerClient.
# The file name must be controller_service.py so
# that ControllerClient can import this module as plugins.

__all__ = ["RotationResource"]
latest_api_version = "2"

# ---------------------------------------------------------------------------- #
# Configuration: /rotate/*
# ---------------------------------------------------------------------------- #
class RotationResource:

    @RefreshRetry
    def rotate_credentials(self, api_version=latest_api_version):
        try:
            api = PasswordRouterApi(api_client=self.api_client)
            response = api.api_vversion_bdc_password_rotate_patch(api_version)
            return response
        except ApiError as e:
            raise ControllerError(
                e, status=e.status, response_json=e.response_json
            )
